import config
import json
import logging
import mqtt
import report
import subprocess
import time

try:
    from config import APP_NAME as ROOT_LOGGER_NAME
except ImportError:
    ROOT_LOGGER_NAME = 'root'
logger = logging.getLogger(ROOT_LOGGER_NAME).getChild('main')


class exec_command(mqtt.mqtt_client):
    def __init__(self):
        self.__block_execution__ = False
        mqtt.mqtt_client.__init__(self, config.APP_NAME, config.MQTT_SERVER, 1883, config.MQTT_USER, config.MQTT_PASS)
        self.add_callback(config.TOPIC, self.mqtt_rx)
        # Start a pseudo process
        self.process = subprocess.Popen(["sleep", "0"])

    def exec_command(self):
        self.process = subprocess.Popen(config.COMMAND.split(" "))

    def mqtt_rx(self, client, userdate, message):
        data = None
        if config.PAYLOAD_KEY is None:
            try:
                data = message.payload.decode('utf-8')
            except:
                logger.exception("Error decoding mqtt message")
        else:
            try:
                payload = json.loads(message.payload)
            except:
                logger.exception("Error decoding json mqtt message")
            else:
                data = payload.get(config.PAYLOAD_KEY)
        if config.PAYLOAD_DATA is None or data == config.PAYLOAD_DATA:
            if self.process.poll() is None:
                self.process.kill()
            logger.debug("Starting execution in background...")
            self.exec_command()


if __name__ == '__main__': 
    report.appLoggingConfigure(config.__BASEPATH__, config.LOGTARGET, ((config.APP_NAME, config.LOGLVL), ), fmt=config.formatter, host=config.LOGHOST, port=config.LOGPORT)
    #
    ec = exec_command()
    #
    while True:
        time.sleep(30)
    try:
        ec.join()
    finally:
        ec.stop()
